=== debian/changelog ===
hipfft (6.1.2-3build1) questing; urgency=medium

  * No-change rebuild for boost 1.88.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 07 Aug 2025 08:18:36 +0200

hipfft (6.1.2-3) unstable; urgency=medium

  * d/libhipfft0-tests.install: fix typo in install directory
  * d/rules: explicitly specify target GPU architectures
  * d/rules: enable nocheck to be used with DEB_BUILD_OPTION without
    also setting nocheck for DEB_BUILD_PROFILE
  * d/rules: use DEB_HOST_GNU_TYPE when referring to the build directory
  * Update symbols for 6.1.2 upstream version

 -- Cordell Bloor <cgmb@slerp.xyz>  Wed, 03 Jul 2024 13:50:26 -0600

hipfft (6.1.2-2) unstable; urgency=medium

  * Add missing Build-Depends libhiprand-dev <!nocheck>

 -- Kari Pahula <kaol@debian.org>  Tue, 02 Jul 2024 09:46:56 +0300

hipfft (6.1.2-1) unstable; urgency=medium

  * New upstream version
  * Enable tests and add a new package libhipfft0-tests for them
  * Remove patches that had been included to upstream
  * Patch doxygen definitions to use typedef names more consistently
  * Standards-Version 4.7.0 (no changes necessary)

 -- Kari Pahula <kaol@debian.org>  Mon, 01 Jul 2024 10:16:17 +0300
