## hipfft 6.4.1

=== debian/changelog ===
hipfft (6.4.1-1~exp1) experimental; urgency=medium

  [ Cordell Bloor ]
  * d/rules: fix path to test utility

  [ Christian Kastner ]
  * New upstream version 6.4.1
  * Drop obsolete patches
  * Refresh patches
  * Add use-local-mathjax.patch
  * Add Extend-docs-conf.py-for-offline-build.patch
  * Add Switch-find_package-to-module-mode.patch
  * Build documentation with python3-rocm-docs
  * Bump rocfft, rocrand dependencies
  * Switch test runner over to universal location
  * librocsparse1.symbols:
    - libhipfft0.symbols: Drop C++ symbols
    - Filter out anything not hipfft_*
  * d/rules: Drop -S, cmake is inferred
  * Bump Standards-Version to 4.7.2 (no changes needed)
  * Update d/copyright
  * Update d/gbp.conf to reflect Team use

 -- Christian Kastner <ckk@debian.org>  Sun, 29 Jun 2025 20:05:14 +0200
