=== debian/control ===
--- 
+++ 
@@ -2,7 +2,7 @@
 Section: devel
 Homepage: https://github.com/ROCm/hipfft
 Priority: optional
-Standards-Version: 4.6.2
+Standards-Version: 4.7.2
 Vcs-Git: https://salsa.debian.org/rocm-team/hipfft.git
 Vcs-Browser: https://salsa.debian.org/rocm-team/hipfft
 Maintainer: Debian ROCm Team <debian-ai@lists.debian.org>
@@ -14,16 +14,15 @@
                hipcc (>= 5.6.1~),
                cmake,
                rocm-cmake,
-               librocfft-dev (>= 6.1.2),
+               librocfft-dev (>= 6.4.1~),
                libboost-program-options-dev <!nocheck>,
                libfftw3-dev <!nocheck>,
-               libhiprand-dev <!nocheck>,
+               libhiprand-dev (>= 6.4.1~) <!nocheck>,
                libgtest-dev <!nocheck>
 Build-Depends-Indep: dh-sequence-sphinxdoc <!nodoc>,
-               doxygen <!nodoc>,
-               python3-breathe <!nodoc>,
-               python3-sphinx <!nodoc>,
-               python3-sphinx-rtd-theme <!nodoc>,
+               python3-doxysphinx <!nodoc>,
+               python3-rocm-docs (>= 1.20.0-1~) <!nodoc>,
+               python3-sphinx-external-toc <!nodoc>,
                libjs-jquery <!nodoc>,
                libjs-mathjax <!nodoc>,
                libjs-sphinxdoc <!nodoc>,
