=== debian/rules ===
--- 
+++ 
@@ -20,7 +20,7 @@
 endif
 
 %:
-	dh $@ -Scmake
+	dh $@
 
 override_dh_auto_configure-arch:
 	dh_auto_configure -- $(CMAKE_FLAGS)
@@ -29,7 +29,7 @@
 ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
 	set -e \
 	; if [ -r /dev/kfd ] \
-	; then $(DEB_HOST_GNU_TYPE)/clients/staging/hipfft-test \
+	; then obj-$(DEB_HOST_GNU_TYPE)/clients/staging/hipfft-test \
 	; else echo "W: /dev/kfd unreadable: no available AMD GPU." \
 	;      echo "W: tests skipped." \
 	; fi
@@ -40,7 +40,11 @@
 
 override_dh_auto_build-indep:
 ifeq (,$(filter nodoc,$(DEB_BUILD_OPTIONS)))
-	cd docs/.doxygen && doxygen
+	http_proxy='127.0.0.1:9' \
+	https_proxy='127.0.0.1:9' \
+	ROCM_DOCS_REMOTE_DETAILS=http://localhost,local \
+	latest_version= \
+	release_candidate= \
 	sphinx-build -b html docs html
 endif
